//+--------------------------------------------------------------------------------------------------------------+
//|   60 Seconds In&Out Bars                                                                                     |
//|                                                                                                              |
//|   Copyright  2014 / airquest@hotmail.com                                                                    |
//|                                                                                                              |
//|   http://smart-trading.world-record.ch                                                                       |
//|   based on http://www.binaryoptionsedge.com/index.php?/topic/562-the-best-and-most-accurate-60-sec-strategy/ |
//+--------------------------------------------------------------------------------------------------------------+


   #property copyright   "Copyright  2014 // airquest // smart-trading.world-record.ch"
   #property link        "http://smart-trading.world-record.ch"
   #property description "60 Seconds In&Out Bars"


//------------------------------------------------------------------

#property indicator_chart_window
#property indicator_buffers 2

#property indicator_color1 Lime
#property indicator_color2 Red
#property indicator_width1 2
#property indicator_width2 2

//+------------------------------------------------------------------+

extern int    MinutesExpiry                   = 1;
extern bool   RunBacktest                     = True;
extern bool   UpdateOnNewBarOnly_NotEveryTick = True;
extern bool   ShowLines                       = True;

//+------------------------------------------------------------------+

extern bool   ShowArrows = True;
extern bool   ShowLabels = True;

extern int    BBPeriod   =  1;
extern int    BBPrice    = PRICE_CLOSE;
extern int    BBDev      =   2;

extern double ArrowsDisplacement = 1;
extern color  ArrowsUpColor      = Lime;
extern color  ArrowsDnColor      = Red;
extern int    ArrowsUpCode       = 233;
extern int    ArrowsDnCode       = 234;
extern int    ArrowsWidth        = 2;

extern bool   AlertsOn        = True;
extern bool   AlertsOnCurrent = True;
extern bool   AlertsMessage   = True;
extern bool   AlertsEmail     = False;
extern bool   AlertsPush      = False;
extern bool   AlertsSound     = False;

extern color  LabelBuyColor  = Lime;
extern color  LabelSellColor = Red;
extern int    LabelFontWidth = 14;
extern int    LabelCorner    =  1;
extern int    LabelYDistance =  0;
extern int    LabelXDistance =  0;
extern int    LinesStyle     =  2;
extern int    LinesWidth     =  1;
extern string UniqueID       = "60 Seconds In&Out Bars";

//+------------------------------------------------------------------+

double ArrowsBuy[];
double ArrowsSell[];
double trend[];
bool   up = False;

//+------------------------------------------------------------------+

double count[];
double itm[];
double expiry_price[];

int      count_total, count_itm, count_otm;
double   count_winrate;
int      gLimit;
bool     gbFirstTime = True;
datetime gdtLastChecked;
datetime gdtFirstBar;

//+------------------------------------------------------------------+

int ADXbars = 4;
int CountBars = 99999;

//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
   IndicatorBuffers(6);

   SetIndexBuffer(0,ArrowsBuy);     SetIndexStyle(0,DRAW_ARROW,NULL,ArrowsWidth,ArrowsUpColor); SetIndexArrow(0,ArrowsUpCode);
   SetIndexBuffer(1,ArrowsSell);    SetIndexStyle(1,DRAW_ARROW,NULL,ArrowsWidth,ArrowsDnColor); SetIndexArrow(1,ArrowsDnCode);
   SetIndexBuffer(2,trend);

//+------------------------------------------------------------------+

   SetIndexBuffer(3,count);
   SetIndexBuffer(4,itm);
   SetIndexBuffer(5,expiry_price);

//+------------------------------------------------------------------+

   SetIndexLabel(0,"Buy Signals");
   SetIndexLabel(1,"Sell Signals");

   if(!ShowArrows)   { SetIndexStyle(0,DRAW_NONE); SetIndexStyle(1,DRAW_NONE); }

   return(0);
}

int deinit()
{
   DeleteLabels();

//+------------------------------------------------------------------+

   DeleteBackTest();
   DeleteLines();

//+------------------------------------------------------------------+

   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
{
   int counted_bars = IndicatorCounted();
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   int limit = MathMin(Bars-counted_bars,Bars-1);

//+------------------------------------------------------------------+

   if (gbFirstTime)
   {
      gdtFirstBar = Time[limit];
      gbFirstTime = False;
   }

//+------------------------------------------------------------------+

   for(int i=limit; i>=0; i--)
     {
         //double BandsUp  = iBands(NULL,0,BBPeriod,BBDev,0,BBPrice,1,i+2);
         //double BandsDn  = iBands(NULL,0,BBPeriod,BBDev,0,BBPrice,2,i+2);

         bool   is60Buy  = (iCustom(Symbol(),0,"SixtySecondTrades",ADXbars,CountBars,0,i+1) > 0);
         bool   is60Sell = (iCustom(Symbol(),0,"SixtySecondTrades",ADXbars,CountBars,1,i+1) > 0);

         trend[i]   = trend[i+1];

         if      (High[i+1] >= High[i+2] && Low[i+1] <= Low[i+2] && Close[i] <= Low[i+1]  && is60Sell) trend[i] = -1;
         else if (High[i+1] >= High[i+2] && Low[i+1] <= Low[i+2] && Close[i] >= High[i+1] && is60Buy)  trend[i] =  1;
         else    trend[i] = 0;

         double gap  = iATR(NULL,0,100,i);
         double high = High[i] + gap * ArrowsDisplacement;
         double low  = Low[i]  - gap * ArrowsDisplacement;

         ArrowsBuy[i]    = EMPTY_VALUE;
         ArrowsSell[i]   = EMPTY_VALUE;

         if(trend[i] != trend[i+1] && trend[i] ==  1)
         {
            ArrowsBuy[i]  = low;
            if(AlertsOn)
            {
               if (AlertsOnCurrent)
                  int whichBar = 0;
               else   whichBar = 1;
               doAlert(whichBar,"Call Signal - "+MinutesExpiry+" min. expiry");
               up = True;
               if(ShowLabels) AddLabels();
            }
         }
         else if(trend[i] != trend[i+1] && trend[i] == -1)
         {
            ArrowsSell[i] = high;
            if(AlertsOn)
            {
               if (AlertsOnCurrent)
                      whichBar = 0;
               else   whichBar = 1;
               doAlert(whichBar,"Put Signal - "+MinutesExpiry+" min. expiry");
               up = False;
               if(ShowLabels) AddLabels();
            }
         }
         else if(trend[i] == 0) DeleteLabels();
     }
   
//+------------------------------------------------------------------+

   count_total   = 0;
   count_itm     = 0;
   count_otm     = 0;
   count_winrate = 0;

   if(RunBacktest && UpdateOnNewBarOnly_NotEveryTick && gdtLastChecked == Time[0]) RunBacktest = False;

   if(RunBacktest)
   {
        int iBar = iBarShift(NULL,PERIOD_CURRENT,gdtFirstBar);
        for(i=iBar; i>=0; i--)
        {
            datetime time_for_entry = iTime(NULL,0,i);
            datetime expiry_time    = iTime(NULL,0,i-1);

            int iBarExp     = iBarShift(NULL,0,expiry_time,False);
            expiry_price[i] = iOpen(NULL,0,iBarExp);
            expiry_time     = Time[iBarExp];

            if   (ArrowsBuy[i] != EMPTY_VALUE || ArrowsSell[i] != EMPTY_VALUE)
                 count[i] = 1;
            else count[i] = 0;
   
            if   ((ArrowsBuy[i] != EMPTY_VALUE && Open[i] < expiry_price[i]) || (ArrowsSell[i] != EMPTY_VALUE && Open[i] > expiry_price[i]))
                 itm[i] = 1;
            else itm[i] = 0;
        }

        if (ShowLines && count[i] == 1)
        {
            color clrColor = Red;
            if (itm[i] == 1) clrColor = Lime;
            if (time_for_entry != 0) DrawLines(time_for_entry,expiry_time,Open[i],expiry_price[i],clrColor);
        }

        for(i=0; i<=iBar; i++)
        {
            count_total += count[i];
            count_itm   += itm[i];
            count_otm    = count_total - count_itm;
        }

        count_winrate = count_itm * 100 / count_total;

        BackTest(count_total,count_itm,count_otm,count_winrate);

        if(UpdateOnNewBarOnly_NotEveryTick) gdtLastChecked = Time[0];
   }

//+------------------------------------------------------------------+

   return(0);
}

//+------------------------------------------------------------------+

void BackTest(int total_of_trades, int total_itm, int total_otm, double total_winrate)
{
   string name = UniqueID+" BackTest";
   color Color_Winrate; if (total_winrate < 50) Color_Winrate = Red; else Color_Winrate = Green;
   
   ObjectCreate(0,name+"1",OBJ_LABEL,0,Time[0],Close[0]);
   ObjectSetText(name+"1","Signals: "+IntegerToString(total_of_trades),15,NULL,Green);
   ObjectSet(name+"1",OBJPROP_XDISTANCE,LabelXDistance+90);
   ObjectSet(name+"1",OBJPROP_YDISTANCE,LabelYDistance+50);
   ObjectSet(name+"1",OBJPROP_CORNER,LabelCorner);
   ObjectSet(name+"1",OBJPROP_ANCHOR,ANCHOR_CENTER);
   
   ObjectCreate(0,name+"2",OBJ_LABEL,0,Time[0],Close[0]);
   ObjectSetText(name+"2","Win",12,NULL,Green);
   ObjectSet(name+"2",OBJPROP_XDISTANCE,LabelXDistance+150);
   ObjectSet(name+"2",OBJPROP_YDISTANCE,LabelYDistance+75);
   ObjectSet(name+"2",OBJPROP_CORNER,LabelCorner);
   ObjectSet(name+"2",OBJPROP_ANCHOR,ANCHOR_CENTER);
   
   ObjectCreate(0,name+"3",OBJ_LABEL,0,Time[0],Close[0]);
   ObjectSetText(name+"3","Lose",12,NULL,Red);
   ObjectSet(name+"3",OBJPROP_XDISTANCE,LabelXDistance+100);
   ObjectSet(name+"3",OBJPROP_YDISTANCE,LabelYDistance+75);
   ObjectSet(name+"3",OBJPROP_CORNER,LabelCorner);
   ObjectSet(name+"3",OBJPROP_ANCHOR,ANCHOR_CENTER);
   
   ObjectCreate(0,name+"4",OBJ_LABEL,0,Time[0],Close[0]);
   ObjectSetText(name+"4","WinRate",12,NULL,Color_Winrate);
   ObjectSet(name+"4",OBJPROP_XDISTANCE,LabelXDistance+40);
   ObjectSet(name+"4",OBJPROP_YDISTANCE,LabelYDistance+75);
   ObjectSet(name+"4",OBJPROP_CORNER,LabelCorner);
   ObjectSet(name+"4",OBJPROP_ANCHOR,ANCHOR_CENTER);
   
   ObjectCreate(0,name+"5",OBJ_LABEL,0,Time[0],Close[0]);
   ObjectSetText(name+"5",IntegerToString(total_itm),12,NULL,Green);
   ObjectSet(name+"5",OBJPROP_XDISTANCE,LabelXDistance+150);
   ObjectSet(name+"5",OBJPROP_YDISTANCE,LabelYDistance+100);
   ObjectSet(name+"5",OBJPROP_CORNER,LabelCorner);
   ObjectSet(name+"5",OBJPROP_ANCHOR,ANCHOR_CENTER);
   
   ObjectCreate(0,name+"6",OBJ_LABEL,0,Time[0],Close[0]);
   ObjectSetText(name+"6",IntegerToString(total_otm),12,NULL,Red);
   ObjectSet(name+"6",OBJPROP_XDISTANCE,LabelXDistance+100);
   ObjectSet(name+"6",OBJPROP_YDISTANCE,LabelYDistance+100);
   ObjectSet(name+"6",OBJPROP_CORNER,LabelCorner);
   ObjectSet(name+"6",OBJPROP_ANCHOR,ANCHOR_CENTER);
   
   ObjectCreate(0,name+"7",OBJ_LABEL,0,Time[0],Close[0]);
   ObjectSetText(name+"7",DoubleToString(total_winrate,1)+"%",12,NULL,Color_Winrate);
   ObjectSet(name+"7",OBJPROP_XDISTANCE,LabelXDistance+40);
   ObjectSet(name+"7",OBJPROP_YDISTANCE,LabelYDistance+100);
   ObjectSet(name+"7",OBJPROP_CORNER,LabelCorner);
   ObjectSet(name+"7",OBJPROP_ANCHOR,ANCHOR_CENTER);
}

void DeleteBackTest()
{
   string name = UniqueID+" BackTest";
   for(int i=0; i<8; i++) ObjectDelete(name+""+i);
}

void DrawLines(int dtDateFrom, int dtDateTo, double dPriceFrom, double dPriceTo, color clrColor) 
{
   string name = UniqueID+" Lines" + "_" + dtDateFrom;

   ObjectCreate(name,OBJ_TREND,0,dtDateFrom,dPriceFrom,dtDateTo,dPriceTo);
   ObjectMove(name,1,dtDateTo,dPriceTo);
   ObjectSet(name,OBJPROP_COLOR,clrColor);
   ObjectSet(name,OBJPROP_RAY,False);
   ObjectSet(name,OBJPROP_STYLE,LinesStyle);
   ObjectSet(name,OBJPROP_WIDTH,LinesWidth);
   ObjectSet(name,OBJPROP_BACK,False);
}

void DeleteLines()
{
   for(int i=ObjectsTotal()-1; i>=0; i--)
   {
       string name  = UniqueID+" Lines";
       string label = ObjectName(i);
       if(StringSubstr(label,0,StringLen(name)) != name)
           continue;
       ObjectDelete(label);   
   }   
}

//+------------------------------------------------------------------+

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert = "Nothing";
   static datetime previousTime;
   string message;

   if (previousAlert != doWhat && previousTime != Time[forBar])
   {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       message = StringConcatenate(Symbol()," - ",TimeFrameToString(Period())," - 60 Second Strat: ",doWhat);
          if (AlertsMessage) Alert(message);
          if (AlertsEmail)   SendMail(StringConcatenate(Symbol(),"60 Second Strat: "),message);
          if (AlertsPush)    SendNotification(message);
          if (AlertsSound)   PlaySound("alert2.wav");
   }
}

string TimeFrameToString(int tf)
{
   string tfs;

   switch(tf)
   {
      case PERIOD_M1:     tfs = "M1";      break;
      case PERIOD_M5:     tfs = "M5";      break;
      case PERIOD_M15:    tfs = "M15";     break;
      case PERIOD_M30:    tfs = "M30";     break;
      case PERIOD_H1:     tfs = "H1";      break;
      case PERIOD_H4:     tfs = "H4";      break;
      case PERIOD_D1:     tfs = "D1";      break;
      case PERIOD_W1:     tfs = "W1";      break;
      case PERIOD_MN1:    tfs = "MN";
      default: tfs = "M" + DoubleToStr(tf,0);
   }
   return(tfs);
}

//+------------------------------------------------------------------+

void AddLabels()
{
   string name = UniqueID+" Labels";
   if(up)
   {
      ObjectDelete(name);
      ObjectCreate(0,name,OBJ_LABEL,0,Time[0],Close[0]);
      ObjectSetText(name,"Call Signal - "+MinutesExpiry+" min. expiry",LabelFontWidth,NULL,LabelBuyColor);
      ObjectSet(name,OBJPROP_XDISTANCE,LabelXDistance);
      ObjectSet(name,OBJPROP_YDISTANCE,LabelYDistance);
      ObjectSet(name,OBJPROP_CORNER,LabelCorner);
   }
   else if(!up)
   {
      ObjectDelete(name);
      ObjectCreate(0,name,OBJ_LABEL,0,Time[0],Close[0]);
      ObjectSetText(name,"Put Signal - "+MinutesExpiry+" min. expiry",LabelFontWidth,NULL,LabelSellColor);
      ObjectSet(name,OBJPROP_XDISTANCE,LabelXDistance);
      ObjectSet(name,OBJPROP_YDISTANCE,LabelYDistance);
      ObjectSet(name,OBJPROP_CORNER,LabelCorner);
   }
}

void DeleteLabels()
{
   string name = UniqueID+" Labels";
   ObjectDelete(name);
}